<template>
  <div class="link-browser-details">
    <ob-table
      v-if="source && source.length"
      :columns="columns"
      :items="sortedRoles"
      @select="handleClick"
    >
      <div slot="link" slot-scope="{ data }">
        <template
          v-if="data.item.uuid === userData.contractor_uuid"
        >
          <span class="green">{{ dictionaryRu.linkStatus.currentUser}}</span>
        </template>
        <template
          v-else-if="!data.item.restriction"
        >
          <span
            v-if="false && (data.item.public_pending || data.item.pending)"
            class="gray"
          >
            {{ dictionaryRu.linkStatus.pending }}
          </span>
          <template v-else>
            <i :class="`fs15 icon blue ${data.item.link_type}`" />
            <span>{{ linkTitleMap[data.item.link_type] }}</span>
          </template>
        </template>
        <template
          v-else-if="data.item.restriction"
        >
          <i class="icon gray lock fs15" />
          <span class="gray">{{ dictionaryRu.linkStatus.restriction }}</span>
        </template>
      </div>

      <div slot="docs" slot-scope="{ data }">
        <template v-if="data.item.docs > 0">
          <i class="icon blue document fs15" />
          <span>{{ data.docs }}</span>
        </template>
      </div>
    </ob-table>

  </div>
</template>

<script>
import { getCookie } from '@/utils/cookie';
import jwt_decode from 'jwt-decode';
import ObTable from 'common-components/src/obComponents/obTable';
import { dictionary } from '@/translations/ru/LinkBrowserPage';

const token = getCookie('auth_token')
const userData = token ? jwt_decode(token) : {}
const rolesIconMap = {
  'domain-owner': 'role-domain-owner',
  'carrier'     : 'truck',
  'moderator'   : 'role-system-moderator',
  'user'        : 'role-client'
}
const linkTitleMap = {
  'link'      : dictionary.linkType.link,
  'link-left' : dictionary.linkType.linkLeft,
  'link-right': dictionary.linkType.linkRight,
  'link-mutal': dictionary.linkType.linkMutal
}

export default {
  name: 'LinkBrowserDetail',
  props: {
    source: {
      type: Array,
      required: true
    },
    selectedEntry: Object
  },
  components: {
    // row,
    ObTable
  },
  data: () => ({
    dictionaryRu: dictionary,
    gridData: []
  }),
  computed: {
    sortedRoles() {
      const source = this.source;
      const compare = a => {
        if (a.role === 'domain-owner') return -1;

        return 0;
      };

      return source.sort(compare);
    },
    columns() {
      return [
        {
          title: this.dictionaryRu.columnsDetail.role,
          key: 'role',
          html: ({ role }) => {
            const iconClass = rolesIconMap[role]

            return `<i class="icon -cobalt ${iconClass}"></i>`
          }
        },
        {
          title: this.dictionaryRu.columnsDetail.organization,
          key: 'title'
        },
        {
          title: this.dictionaryRu.columnsDetail.status,
          key: 'link_type',
          slotName: 'link'
        },
        {
          title: this.dictionaryRu.columnsDetail.contract,
          key: 'contract_count',
          slotName: 'docs'
        }
      ]
    },
    rolesIconMap() {
      return rolesIconMap
    },
    userData() {
      return userData
    },
    linkTitleMap() {
      return linkTitleMap
    }
  },
  methods: {
    handleClick(data) {
      this.$emit('select-link-org', data);
    }
  }
};
</script>

<style lang="scss" scoped>
.fs15 {
  font-size: 15px;
}
</style>
